/* cisco7 -- Based on L0pht's cracker program for a Palm Pilot  */
/* that cracks Cisco passwords using the "type 7" hash.         */

/* Gary Kessler, 3/3/2000                                       */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define VERSION 1.0
#define VECTOR " dsfd;kfoA,.iyewrkldJKDHSUBsgvca69834nc"

main (int argc, char *argv [])
  {
  char offtmp [2], unhash;
  int vector_len = strlen(VECTOR)-1;
  int offset, j, value;
  void c7error (int);
  int atoh (char);

  /* Error if number of arguements is not exactly 2 */
  if (argc != 2) c7error (1);
  printf ("\nCisco 7 cracker (GCK v%3.1f/%i)\n", VERSION,vector_len);

  /* Error if input string not of even length */
  if (strlen(argv[1]) % 2 != 0) c7error (2);

  /* Get offset value into vector */
  offtmp [0] = argv [1][0];
  offtmp [1] = argv [1][1];
  offtmp [2] = '\0';
  offset = atoi (offtmp);
  if (offset < 0 || offset > vector_len) c7error (3);
  printf ("%c", 0x1);

  for (j=2; j<strlen(argv[1]); j=j+2)
    {
    if (offset > vector_len) c7error (5);
    value = atoh (argv[1][j]) * 16 + atoh (argv[1][j+1]);
    if (value < 0) c7error (4);
    unhash = VECTOR [offset+1] ^ value;
    printf ("%c", unhash);
    offset = offset++;
    }

  printf ("%c\n\n", 0x1);
  }

/* c7error -- Function to print error messages and stop */
void c7error (int errnum)
  {
  switch (errnum)
    {
    case 1:
      printf ("\nInput error: Incorrect number of parameters\n");
      printf ("Usage: cisco7 <type_7_hash_string>\n\n");
      break;
    case 2:
      printf ("\nInput error: Hash string does not contain an even number of characters\n\n");
      break;
    case 3:
      printf ("\nInput error: Error in offset byte value\n\n");
      break;
    case 4:
      printf ("\nInput error: Invalid hex character in hash string\n\n");
      break;
    case 5:
      printf ("%c", 0x1);
      printf ("\nPassword too long... cannot interpret additional characters...\n\n");
    }
  exit (1);
  }

/* atoh -- Function to convert ASCII character to hex. If valid, return */
/* hex value; if invalid, return -256.                                  */

int atoh (char hex_char)
  {
  int value;

  value = isxdigit (hex_char);
  if (value == 0) return (-256);

  if ('0' <= hex_char && hex_char <= '9') return (hex_char - '0');
  hex_char = toupper (hex_char);
  return ((hex_char - 'A') + 10);
  }


